=== debian/changelog ===
libretro-mupen64plus (2.0+git20160207+dfsg2-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 22 Mar 2020 16:46:43 +0100

libretro-mupen64plus (2.0+git20160207+dfsg2-1) unstable; urgency=low

  * Removed compiled libs from gliden64
  * Updated copyright.
  * Added patch to fix hardening-no-fortify-functions.
  * Fixed hardening-no-bindnow.

 -- Sérgio Benjamim <sergio_br2@yahoo.com.br>  Sun, 12 Jun 2016 22:35:00 -0300

libretro-mupen64plus (2.0+git20160207+dfsg1-1) unstable; urgency=low

  * Initial release (Closes: #814344).

 -- Sérgio Benjamim <sergio_br2@yahoo.com.br>  Wed, 01 Jun 2016 22:42:00 -0300
